-- | Provides the version number of @cabal-install@.

module Distribution.Client.Version
  ( cabalInstallVersion
  ) where

import Distribution.Version

-- This value determines the `cabal-install --version` output.
-- 
-- It is used in several places throughout the project, including anonymous build reports, client configuration, 
-- and project planning output. Historically, this was a @Paths_*@ module, however, this conflicted with 
-- program coverage information generated by HPC, and hence was moved to be a standalone value.  
--
cabalInstallVersion :: Version
cabalInstallVersion = mkVersion [3,8,1,0]
